'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (ComposedComponent) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(I, _Component);

    function I() {
      _classCallCheck(this, I);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(I).apply(this, arguments));
    }

    _createClass(I, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (!this.props.infiniteScrollDisabled) {
          var infiniteScrollContainer = this.props.infiniteScrollContainer;


          if (infiniteScrollContainer === 'window') {
            window.addEventListener('scroll', this.handleScroll.bind(this));
          } else {
            document.getElementById(infiniteScrollContainer).addEventListener('mousewheel', this.handleScroll.bind(this));
          }
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (!this.props.infiniteScrollDisabled) {
          var infiniteScrollContainer = this.props.infiniteScrollContainer;


          if (infiniteScrollContainer === 'window') {
            window.removeEventListener('scroll', this.handleScroll.bind(this));
          } else {
            document.getElementById(infiniteScrollContainer).addEventListener('mousewheel', this.handleScroll.bind(this));
          }
        }
      }
    }, {
      key: 'handleScroll',
      value: function handleScroll() {
        var _props = this.props;
        var infiniteScroll = _props.infiniteScroll;
        var infiniteScrollLoading = _props.infiniteScrollLoading;
        var infiniteScrollEnd = _props.infiniteScrollEnd;

        if (this.edgeDistance < this.props.infiniteScrollDistance && !infiniteScrollLoading && !infiniteScrollEnd) {
          infiniteScroll();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'div',
            { ref: this.props.id },
            _react2.default.createElement(ComposedComponent, this.props)
          ),
          this.props.infiniteScrollLoading && this.props.infiniteScrollSpinner,
          this.props.infiniteScrollEnd && this.props.infiniteScrollEndIndicator
        );
      }
    }, {
      key: 'edgeDistance',
      get: function get() {
        var id = this.props.id;

        return this.props.infiniteScrollEdge === 'bottom' ? this.refs[id].getBoundingClientRect().bottom - window.innerHeight : this.refs[id].getBoundingClientRect().top * -1;
      }
    }]);

    return I;
  }(_react.Component), _class.propTypes = {
    id: _react.PropTypes.string.isRequired,
    infiniteScroll: _react.PropTypes.func.isRequired,
    infiniteScrollContainer: _react.PropTypes.string,
    infiniteScrollLoading: _react.PropTypes.bool,
    infiniteScrollEnd: _react.PropTypes.bool,
    infiniteScrollEdge: _react.PropTypes.oneOf(['top', 'bottom']),
    infiniteScrollDistance: _react.PropTypes.number,
    infiniteScrollDisabled: _react.PropTypes.bool,
    infiniteScrollSpinner: _react.PropTypes.element,
    infiniteScrollEndIndicator: _react.PropTypes.element
  }, _class.defaultProps = {
    infiniteScrollContainer: 'window',
    infiniteScrollLoading: false,
    infiniteScrollEnd: false,
    infiniteScrollEdge: 'bottom',
    infiniteScrollDistance: 200,
    infiniteScrollDisabled: false,
    infiniteScrollSpinner: _react2.default.createElement(
      'div',
      null,
      'this is a loader'
    ),
    infiniteScrollEndIndicator: _react2.default.createElement(
      'div',
      null,
      'no more data'
    )
  }, _temp;
};